Index: tools/playlist.c
===================================================================
RCS file: /cvsroot/xineliboutput/vdr-xineliboutput/tools/playlist.c,v
retrieving revision 1.5
diff -u -r1.5 playlist.c
--- tools/playlist.c	4 Jan 2007 13:49:10 -0000	1.5
+++ tools/playlist.c	17 May 2007 13:38:38 -0000
@@ -119,8 +119,26 @@
     while(Running()) {
       if(!(Item = m_List.Next(Item)))
 	break;
+      if(!strcasecmp((Item->Filename) + strlen(Item->Filename) - 5, ".flac")) {
+	cString Cmd = cString::sprintf("metaflac --list --block-type=VORBIS_COMMENT %s", 
+                                       *Item->Filename);
+	cPipe p;
+	if(p.Open(*Cmd, "r")) {
+	  cMutexLock ml(&m_List.m_Lock);
+	  cReadLine r;
+	  char *pt;
+	  while(NULL != (pt = r.Read(p))) {
+            char *d;
+	    if(NULL != (d = strstr(pt, "ARTIST=")))
+              Item->Artist = (d+7);
+            else if(NULL != (d = strstr(pt, "ALBUM=")))
+	      Item->Album = (d+6);
+            else if(NULL != (d = strstr(pt, "TRACK=")))
+              Item->Track = (pt+6);
+	  }
+	}
+      } else
       // id3 tags can be in other files too (eg. flac)
-      /*if(!strcasecmp((Item->Filename) + strlen(Item->Filename) - 4, ".mp3")) {*/
       if(xc.IsAudioFile(Item->Filename)) {
 	cString Cmd = cString::sprintf("mp3info -p \""
 				       "Artist: %%a\\r\\n"
